;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Zmodem's Find File  ;
;                                 ;
;          v1.00              ;
;                                 ;
;      By: Zmodem       ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Aliases

alias find_file if ($dialog(find_file) == $null) { dialog -m find_file find_file }
alias -l qtime .timerQTIME_FF $+ $1 off | .timerQTIME_FF $+ $1 1 0 $1 
alias -l d return find_file
alias -l find_file_runfile {
  if ($did($d,13,$did($d,13).sel) == $null) { return }
  if ($right($did($d,13,$did($d,13).sel),4) == .exe) || $right($did($d,13,$did($d,13).sel),4) == .vbs) || $right($did($d,13,$did($d,13).sel),4) == .bat) || $right($did($d,13,$did($d,13).sel),4) == .com) {
    var %tmp.check.run $?!="Files of this type (exe, vbs, bat, or com) can be files of a malicious nature! Are you *positive* that you want to run this program!"
    if (%tmp.check.run == $false) { return }
    if ($exists($did($d,13,$did($d,13).sel)) == $true) { run $did($d,13,$did($d,13).sel) | return }
    echo -a  $+ $colour(info) $+ *** File not found: $did($d,13,$did($d,13).sel) $+ !
    return
  }
  if ($exists($did($d,13,$did($d,13).sel)) == $true) { run $did($d,13,$did($d,13).sel) | return }
  echo -a  $+ $colour(info) $+ *** File not found: $did($d,13,$did($d,13).sel) $+ !
}
alias -l find_file_clearfields {
  if ($did(find_file,7) == $null) && ($did(find_file,10) == $null) && ($did(find_file,13) == $null) { return }
  var %tmp.clear.yesno $?!="This will clear all fields. Are you sure this is what you want?"
  if (%tmp.clear.yesno == $false) { return }
  did -b $d 2
  did -r $d 7
  did -r $d 10
  did -r $d 13
  did -r $d 14 
  dialog -bsr $d -1 -1 195 42
}
alias -l find_file_begin_search {
  var %tmp.findfile = 1, %tmp.wildcard = $did($d,7).text $+ *, %tmp.holdname, %tmp.amt = $findfile($did($d,10),%tmp.wildcard,0)
  if (%tmp.amt == 0) { did -a $d 14 No string matches found! | goto end }
  while (%tmp.findfile <= %tmp.amt) {
    %tmp.holdname = $findfile($did($d,10),%tmp.wildcard,%tmp.findfile)
    did -a $d 13 %tmp.holdname
    did -ra $d 14 Searching: %tmp.holdname
    inc %tmp.findfile
  }
  did -a $d 14 Found: %tmp.amt matching string(s)
:end
  did -e $dname 8
  did -e $dname 11
  did -e $dname 12
}
alias -l run_readme {
  if ($exists($scriptdirFindFileReadme.txt) == $true) { .run notepad $scriptdirfindfilereadme.txt | return }
  echo -a  $+ $colour(info) $+ *** The file: FindFileReadme.txt (Which was included in the original zip build of my addon) was not found in: $scriptdir $+ . Please ensure that you have this file unzipped to the same directory as this addon. If you did not get this readme file in the Zip package that you downloaded, I suggest downloading from an alternative site: http://members.xoom.com/mircscripts/findfile.zip
}
alias -l find_file_browse {
  var %tmp.find.dir $sdir="Find Drive or Directory To Locate Search String"
  if (%tmp.find.dir == $null) { did -e $d 11 | return }
  if ($dialog($d) == $null) { return }
  did -e $d 11
  did -ra $d 10 %tmp.find.dir
}

;Dialog

dialog find_file {
  option dbu
  size -1 -1 195 55
  title "mIRC Find File"
  menu "&File", 1
  item "Run Selected File", 2
  item break, 3
  item "Exit", 4, cancel
  box "", 5, 2 2 191 4
  text "Search For:", 6, 5 12 28 8
  edit "", 7, 35 11 100 11, multi, return, autohs
  button "Find &Now", 8, 142 11 51 10
  text "Look In:", 9, 8 32 20 8
  edit "", 10, 35 31 65 11, multi, return, autohs
  button "&Browse...", 11, 102 31 33 11
  button "&Clear Fields", 12, 142 31 51 10
  list 13, 10 50 175 85, sort, vsbar
  box "", 14, 10 135 175 4
}
on *:DIALOG:find_file:init:0:did -b $dname 2
on *:DIALOG:find_file:menu:2:qtime find_file_runfile
on *:DIALOG:find_file:sclick:8: {
  var %tmp.7 = $did($dname,7), %tmp.10 = $did($dname,10), %tmp.10false = $exists($did($dname,10))
  if (%tmp.7 == $null) || (%tmp.10 == $null) || (%tmp.10false == $false) { return }
  did -b $dname 8
  did -b $dname 11
  did -b $dname 12
  did -r $dname 13
  dialog -bsr $dname -1 -1 195 145
  find_file_begin_search
}
on *:DIALOG:find_file:sclick:11:did -b $dname $did | qtime find_file_browse
on *:DIALOG:find_file:sclick:12:qtime find_file_clearfields
on *:DIALOG:find_file:sclick:13:if ($did($dname,$did,$did($dname,$did).sel) != $null) { did -e $dname 2 | return }

;Events
on *:LOAD: {
  if ($version < 5.71) {
    echo -a  $+ $colour(info) $+ *** mIRC 5.71 is strongly recommended in order for this addon to work! The MENU support in the dialog may cause problems with earlier versions. Be advised! 
    var %tmp.remove $?!="The current mIRC version that you have ($version) is not supported for this addon. You can still try to run it, but you may run into problems loading it. Do you wish to continue?"
    if (%tmp.remove == $false) { echo -a  $+ $colour(info) $+ *** Zmodem's FindFile v1.00 UNLOADED! | .unload -rs $script }

  }
  echo -a  $+ $colour(info) $+ *** Zmodem's FindFile v1.00 Loaded!
  echo -a  $+ $colour(info) $+ *** To use it, go to your Menubar/Statusbar/Channelbar to open it. Enjoy!
  echo -a  $+ $colour(info) $+ *** Contact me (Zmodem) via e-mail: justinterri@netzero.net
}

;Menus
menu menubar,status,channel {
  Zmodem's FindFile
  .Run Find File:find_file
  .View Readme File:run_readme
}
